local planet = ents.Derive("base")
planet.selectable = true


function planet:load(x, y)
	self:setPos( x, y )
	self.resources = {}
	
	self.productivity = 100 -- Ship production rate
	self.power = 10000 -- Amount of starting ships
	self.lastSpawn = 0
	--self.team = 1
end

function planet:setRadius(rad)
	self.radius = rad
end

function planet:setPlanetType(pType)
	--TODO: Make a garuntee it is a valid type!
	self.pType = pType
end

function planet:draw()
	if not( self.isAlive and self:isVisible() )then return end
	
	local pColor = TEAM_COLORS[self.team]
	
	local sx,sy = self:getSize()
	local tx = self.texture:getWidth() / 2
	local ty = self.texture:getHeight() / 2
	local radScale = clamp(self.radius * zoomScale, 8, 180)
	love.graphics.setColor( pColor[1], pColor[2], pColor[3], 255 )
	
	
	
	--TODO: Fix this. Its slightly bigger than what it should be.
	love.graphics.draw( self.texture, self.x* zoomScale, -self.y* zoomScale, 0,  (self.radius* (1/tx) * zoomScale)*2,  (self.radius* (1/ty) * zoomScale)*2, tx , ty )
	--love.graphics.circle("fill",  self.x * zoomScale,  -self.y * zoomScale, self.radius * zoomScale, 4)
	
	--Draw Info if we are hovered over it
	if (distance(getWorldX(),getWorldY(),self.x,self.y) <= self.radius) then -- Wonder if it will be worthwhile to save worldX and worldY in a variable and update it instead?
		
	
		-- We are on CANVAS now, so Y = -Y
		local tooltipX = (self.x + self.radius + PLAN_PAD )*zoomScale
		local tooltipY = (-self.y - self.radius - PLAN_PAD )*zoomScale
		love.graphics.print( "Planet: " .. self.name, tooltipX, tooltipY, 0, 1, 1 )
		love.graphics.print( "Production Rate: " .. self.productivity .. "%", tooltipX, tooltipY + 14, 0, 1, 1 )
		love.graphics.print( "Power: " .. self.power, tooltipX, tooltipY + 28 , 0, 1, 1 )
		
		love.graphics.print( "Resources:", tooltipX, tooltipY + 50 , 0, 1, 1 )
		if #self.resources == 0 then
			love.graphics.print( "No resources available", tooltipX, tooltipY + 64 , 0, 1, 1 )
		else
			local offset = 64
			for k, v in pairs(self.resources) do
				love.graphics.print( v.name ..": " .. v.amount, tooltipX, tooltipY + offset , 0, 1, 1 )
				offset = offset + 12
			end
		end
	end
	
end	

function planet:spawn()
	self.isAlive = true
	self.radius = self.radius or math.random(3,10)
	self.power = self.radius * 75
	--Fill up our resources
	
	--Determine our color (Or texture in the future)
	
	-- Get a name or generate one
	self.name = self.name or "PLANET " .. self.id
	self.temperature = self.temperature or 78
	self.resources = {{name = "Iron", amount = 100}}
	self.team = self.team or 1
	self.texture = game.planetTextures[self.team]
	-- make some cities?
end

function planet:getSize()
	return self.radius, self.radius
end


function planet:update(dt)

end

return planet
