local rocket =  ents.Derive("base")

function rocket:spawn()
	self.isAlive = true
	self.team = self.team or 1
	self.radius = 1
	self.rot = 0
	self:setSpeed(100)
end

function rocket:setSpeed(speed)
	self.speed = speed
end


function rocket:setTarget(object)
	self.target = object
	--self.destX = object.x
	--self.destY = object.y
end

function rocket:distance(x,y)
	return distance(self.x,self.y, x,y)
end

function rocket:load()
	self.speed = 10
	self.rot = 0
	self.target = {}
end

function rocket:draw(dt)

	love.graphics.setColor( 0, 0, 255, 255 ) 
	--love.graphics.point(self.x * zoomScale,  -self.y * zoomScale)   -- draw each point
	love.graphics.circle("fill",  self.x ,  -self.y , 10 , 4) -- NEGATE Y!
end

--Gets the X and Y bounds of the entity
function rocket:getSize()
	return 5,5 -- Arbitrary value... No significant meaning.
end

function rocket:update(dt)

	self.target.x = getWorldX()
	self.target.y = getWorldY()
	
		maxDist = self.speed * dt
		dist = self:distance(self.target.x, self.target.y)  -- TODO: Optimize this. We can do a rough esitmation based on 2* planet radius!!
	
			-- Targets direction vector
		headX = self.target.x - self.x
		headY = self.target.y - self.y

		self.rot = math.atan2(headY , headX)
		
		 --Find current direction vector
		local dirx = math.cos( self.rot )
		local diry = math.sin( self.rot )
	
		--Update position with our new calculated values
		self.x = self.x + dirx*math.min(dist, maxDist)
		self.y = self.y + diry*math.min(dist, maxDist)
	
end

return rocket;