local ship =  ents.Derive("base")

function ship:spawn()
	self.isAlive = true
	self.team = self.team or 1
	self.radius = 1
	self.rot = 0
	self:setSpeed(SHIP_SPEED +20)
end

function ship:setSpeed(speed)
	self.speed = speed
end


function ship:setTarget(object)
	self.target = object
	--self.destX = object.x
	--self.destY = object.y
end

function ship:distance(x,y)
	return distance(self.x,self.y, x,y)
end

function ship:load()
end

function ship:draw(dt)
	if not( self.isAlive and self:isVisible() )then return end
	local color = TEAM_COLORS[self.team]
	
	local tx = shipText:getWidth() / 2
	local ty = shipText:getHeight() / 2
	
	love.graphics.setColor( color[1], color[2], color[3], 255 ) 
	
	love.graphics.setPointStyle( "rough" )
	love.graphics.setPointSize(self.radius*zoomScale)
	--love.graphics.point(self.x * zoomScale,  -self.y * zoomScale)   -- draw each point
	--love.graphics.circle("fill",  self.x * zoomScale,  -self.y * zoomScale, self.radius * zoomScale, 4) -- NEGATE Y!
	love.graphics.draw( shipText, self.x* zoomScale, -self.y* zoomScale, -self.rot + PI/2,  (self.radius* (1/tx) * zoomScale)*2,  (self.radius* (1/ty) * zoomScale)*2, tx , ty )
end

--Gets the X and Y bounds of the entity
function ship:getSize()
	return 5,5 -- Arbitrary value... No significant meaning.
end

function ship:update(dt)

	maxDist = self.speed * dt
	dist = self:distance(self.target.x, self.target.y)  -- TODO: Optimize this. We can do a rough esitmation based on 2* planet radius!!

	-- This doesnt work flawlessly... but good enough for now.
	if dist <= math.min(self.target:getSize()) then
		self.target:enter(self)
	else
		 --Find current direction vector
		local dirx = math.cos( self.rot )
		local diry = math.sin( self.rot )

		-- Targets direction vector
		headX = self.target.x - self.x
		headY = self.target.y - self.y

		ship.rot = math.atan(headY / headX)
		
		if headX < dirx then
			ship.rot = ship.rot + PI
		end
		
		--[[
		-- RRRRRRRRRRAAAAAAAWWWWWWWWWWRRRRRRRRR! Cant figure this out.
		
		--Add a value scaled by dt to rotate orientation
		if self.rot < ship.desiredRot then
			self.rot = self.rot - math.min(SHIP_ROTSPEED * dt, ship.desiredRot - self.rot)
			--Bound checking for pi and -pi
			if self.rot > PI then
				self.rot = -PI
			elseif self.rot < -PI then
				self.rot = PI
			end
		--Subtract a value scaled by dt to rotate orientation
		elseif self.rot > ship.desiredRot then
		  self.rot = self.rot + math.min(SHIP_ROTSPEED * dt, ship.desiredRot - self.rot)
		  --Bound checking for pi and -pi
			if self.rot > PI then
				self.rot = -PI
			elseif self.rot < -PI then
				self.rot = PI
			end
		end
		--]]
	
		--Update position with our new calculated values
		self.x = self.x + dirx*math.min(dist, maxDist)
		self.y = self.y + diry*math.min(dist, maxDist)
	end
end

return ship;